<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" size="small" v-show="showSearch" label-width="68px">
      <el-form-item label="时间" prop="meetingTime">
        <el-date-picker clearable size="small" style="width: 200px"
          v-model="queryParams.meetingTime"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="选择时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="地点" prop="meetingVenue">
        <el-input
          v-model="queryParams.meetingVenue"
          placeholder="请输入地点"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="主要内容" prop="content">
        <el-input
          v-model="queryParams.content"
          placeholder="请输入主要内容"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="发言记录" prop="records">
        <el-input
          v-model="queryParams.records"
          placeholder="请输入发言记录"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="归属部门" prop="deptId" style="width: 268px;">
        <treeselect style="width: 200px;" v-model="queryParams.deptId" :options="deptOptions" :show-count="true" placeholder="请选择归属部门" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['branch:democratic:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['branch:democratic:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['branch:democratic:remove']"
        >删除</el-button>
      </el-col>
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="info"-->
          <!--plain-->
          <!--icon="el-icon-upload2"-->
          <!--size="mini"-->
          <!--@click="handleImport"-->
          <!--v-hasPermi="['branch:democratic:edit']"-->
        <!--&gt;导入</el-button>-->
      <!--</el-col>-->
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="warning"-->
          <!--plain-->
          <!--icon="el-icon-download"-->
          <!--size="mini"-->
          <!--@click="handleExport"-->
          <!--v-hasPermi="['branch:democratic:export']"-->
        <!--&gt;导出</el-button>-->
      <!--</el-col>-->
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="democraticList" @selection-change="handleSelectionChange" :height="clientHeight" border>
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="时间" align="center" prop="meetingTime" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.meetingTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="地点" align="center" prop="meetingVenue" width="120" />
      <el-table-column label="主持人" align="center" prop="hostString" width="120"/>
      <el-table-column label="记录人" align="center" prop="recorderString" width="120"/>
      <el-table-column label="参加人员" align="center" prop="participantsString" width="120"/>
      <el-table-column label="主要内容" align="left" prop="content" width="350" />
      <el-table-column label="发言记录" align="left" prop="records" width="350" />
      <el-table-column label="操作" align="center" fixed="right" width="120" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['branch:democratic:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['branch:democratic:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改民主生活会对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-row>
          <el-col :span="12">
            <el-form-item label="时间" prop="meetingTime">
              <el-date-picker clearable size="small" style="width: 200px"
                              v-model="form.meetingTime"
                              type="date"
                              value-format="yyyy-MM-dd"
                              placeholder="选择时间">
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="地点" prop="meetingVenue">
              <el-input v-model="form.meetingVenue" placeholder="请输入地点" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="主持人" prop="host">
              <el-select v-model="form.host" multiple placeholder="请选择主持人">
                <el-option
                  v-for="dict in userList"
                  :key="dict.dictValue"
                  :label="dict.dictLabel"
                  :value="dict.dictValue"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="记录人" prop="recorder">
              <el-select v-model="form.recorder" multiple placeholder="请选择记录人">
                <el-option
                  v-for="dict in userList"
                  :key="dict.dictValue"
                  :label="dict.dictLabel"
                  :value="dict.dictValue"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="参加人员" prop="participants">
              <el-select v-model="form.participants" multiple placeholder="请选择参加人员">
                <el-option
                  v-for="dict in userList"
                  :key="dict.dictValue"
                  :label="dict.dictLabel"
                  :value="dict.dictValue"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="归属部门" prop="deptId">
              <treeselect v-model="form.deptId" :options="deptOptions" :show-count="true" placeholder="请选择归属部门" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="主要内容" prop="content">
              <el-input v-model="form.content" type="textarea" placeholder="请输入内容" rows="4" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="发言记录" prop="records">
              <el-input v-model="form.records" type="textarea" placeholder="请输入内容" rows="4" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 用户导入对话框 -->
    <el-dialog :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
        <el-upload
                ref="upload"
                :limit="1"
                accept=".xlsx, .xls"
                :headers="upload.headers"
                :action="upload.url + '?updateSupport=' + upload.updateSupport"
                :disabled="upload.isUploading"
                :on-progress="handleFileUploadProgress"
                :on-success="handleFileSuccess"
                :auto-upload="false"
                drag
        >
            <i class="el-icon-upload"></i>
            <div class="el-upload__text">
                将文件拖到此处，或
                <em>点击上传</em>
            </div>
            <div class="el-upload__tip" slot="tip">
                <el-checkbox v-model="upload.updateSupport" />是否更新已经存在的用户数据
                <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>
            </div>
            <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
        </el-upload>
        <div slot="footer" class="dialog-footer">
            <el-button type="primary" @click="submitFileForm">确 定</el-button>
            <el-button @click="upload.open = false">取 消</el-button>
        </div>
    </el-dialog>
  </div>
</template>

<script>
import { listDemocratic, getDemocratic, delDemocratic, addDemocratic, updateDemocratic, exportDemocratic, importTemplate} from "@/api/branch/democratic";
import { treeselect } from "@/api/system/dept";
import { getToken } from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import { listUserNoPage } from "@/api/system/user";

export default {
  name: "Democratic",
  components: { Treeselect },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 民主生活会表格数据
      democraticList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight:300,
      // 是否显示弹出层
      open: false,
        // 用户导入参数
        upload: {
            // 是否显示弹出层（用户导入）
            open: false,
            // 弹出层标题（用户导入）
            title: "",
            // 是否禁用上传
            isUploading: false,
            // 是否更新已经存在的用户数据
            updateSupport: 0,
            // 设置上传的请求头部
            headers: { Authorization: "Bearer " + getToken() },
            // 上传的地址
            url: process.env.VUE_APP_BASE_API + "/branch/democratic/importData"
        },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        democraticId: null,
        meetingTime: null,
        meetingVenue: null,
        host: null,
        recorder: null,
        participants: null,
        content: null,
        records: null,
        deptId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        meetingTime: [
          { required: true, message: "时间不能为空", trigger: "blur" }
        ],
        meetingVenue: [
          { required: true, message: "地点不能为空", trigger: "blur" }
        ],
        deptId: [
          { required: true, message: "归属部门不能为空", trigger: "blur" }
        ],
      },
      // 用户列表
      userList: [],
    };
  },
  watch: {
        // 根据名称筛选部门树
        deptName(val) {
            this.$refs.tree.filter(val);
        }
   },
  created() {
      //设置表格高度对应屏幕高度
      this.$nextTick(() => {
          this.clientHeight = document.body.clientHeight -250
      })
    this.getList();
    this.getTreeselect();
  },
  methods: {
    /** 查询民主生活会列表 */
    getList() {
      this.loading = true;
      listUserNoPage().then(response => {
        let rows = response.data;
        let userList = [];
        for(let i = 0; i < rows.length; i++) {
          if (rows[i].userName != "admin") {
            let user = { "dictValue" : rows[i].userId, "dictLabel" : rows[i].nickName};
            userList.push(user);
          }
        }
        this.userList = userList;
        listDemocratic(this.queryParams).then(response => {
          this.democraticList = response.rows;
          for (let i = 0; i < this.democraticList.length; i++) {
            if (this.democraticList[i].host != null) {
              let host = this.democraticList[i].host.split(",");
              let hostString = "";
              for (let j = 0; j < host.length; j++) {
                if (j > 0) {
                  hostString += "、" + this.selectDictLabel(this.userList, host[j]);
                } else {
                  hostString += this.selectDictLabel(this.userList, host[j]);
                }
              }
              this.democraticList[i].hostString = hostString;
            }
            if (this.democraticList[i].recorder != null) {
              let recorder = this.democraticList[i].recorder.split(",");
              let recorderString = "";
              for (let j = 0; j < recorder.length; j++) {
                if (j > 0) {
                  recorderString += "、" + this.selectDictLabel(this.userList, recorder[j]);
                } else {
                  recorderString += this.selectDictLabel(this.userList, recorder[i]);
                }
              }
              this.democraticList[i].recorderString = recorderString;
            }
            if (this.democraticList[i].participants != null) {
              let participants = this.democraticList[i].participants.split(",");
              let participantsString = "";
              for (let j = 0; j < participants.length; j++) {
                if (j > 0) {
                  participantsString += "、" + this.selectDictLabel(this.userList, participants[j]);
                } else {
                  participantsString += this.selectDictLabel(this.userList, participants[j]);
                }
              }
              this.democraticList[i].participantsString = participantsString;
            }
          }
          this.total = response.total;
          this.loading = false;
        });
      });
    },
     /** 查询部门下拉树结构 */
     getTreeselect() {
          treeselect().then(response => {
              this.deptOptions = response.data;
          });
     },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        democraticId: null,
        meetingTime: null,
        meetingVenue: null,
        host: null,
        recorder: null,
        participants: null,
        content: null,
        records: null,
        delFlag: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        deptId: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.democraticId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加民主生活会";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const democraticId = row.democraticId || this.ids
      getDemocratic(democraticId).then(response => {
        this.form = response.data;
        if (this.form.host != null) {
          this.form.host = this.form.host.split(",").map(Number);
        }
        if (this.form.recorder != null) {
          this.form.recorder = this.form.recorder.split(",").map(Number);
        }
        if (this.form.participants != null) {
          this.form.participants = this.form.participants.split(",").map(Number);
        }
        this.open = true;
        this.title = "修改民主生活会";
      });
    },
      /** 提交按钮 */
      submitForm() {
        if (this.form.host != null) {
          this.form.host = this.form.host.join();
        }
        if (this.form.recorder != null) {
          this.form.recorder = this.form.recorder.join();
        }
        if (this.form.participants != null) {
          this.form.participants = this.form.participants.join();
        }
          this.$refs["form"].validate(valid => {
              if (valid) {
                  if (this.form.democraticId != null) {
                      updateDemocratic(this.form).then(response => {
                          this.$modal.msgSuccess("修改成功");
                          this.open = false;
                          this.getList();
                      });
                  } else {
                      addDemocratic(this.form).then(response => {
                          this.$modal.msgSuccess("新增成功");
                          this.open = false;
                          this.getList();
                      });
                  }
              }
          });
      },
    /** 删除按钮操作 */
    handleDelete(row) {
      const democraticIds = row.democraticId || this.ids;
      this.$confirm('是否确认删除?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delDemocratic(democraticIds);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有民主生活会数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportDemocratic(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    },
      /** 导入按钮操作 */
      handleImport() {
          this.upload.title = "用户导入";
          this.upload.open = true;
      },
      /** 下载模板操作 */
      importTemplate() {
          importTemplate().then(response => {
              this.download(response.msg);
          });
      },
      // 文件上传中处理
      handleFileUploadProgress(event, file, fileList) {
          this.upload.isUploading = true;
      },
      // 文件上传成功处理
      handleFileSuccess(response, file, fileList) {
          this.upload.open = false;
          this.upload.isUploading = false;
          this.$refs.upload.clearFiles();
          this.$alert(response.msg, "导入结果", { dangerouslyUseHTMLString: true });
          this.getList();
      },
      // 提交上传文件
      submitFileForm() {
          this.$refs.upload.submit();
      }
  }
};
</script>

<style>
    /** 文本换行符处理 */
    .el-table .cell{
        white-space: pre-wrap;
    }
    /** textarea字体 */
    textarea {
        font-family: "Helvetica Neue",Helvetica,"PingFang SC","Hiragino Sans GB","Microsoft YaHei","微软雅黑",Arial,sans-serif;
    }
</style>
